/* 	PLUGIN VOTE-FOR-IT 2
	WRITTEN BY: [WING] Sir Drink a lot
	visit www.adminmod.de

	DESCRIPTION: 	At the moment, you can start a vote for several maps, a single map, extending current map, ff, chasecam,
			forbiding awp, using pistols only and gravity and more... You need access-level 2 for using
			this plugin. Of course, you can also cancel the votes.
			All votes are using the graphical vote display.

	NEW:		-If no admin is on the server and VFI_PUBLIC is set to 1 in vault.ini, nonadmins can start votes, which are
			defined in publicvotes.ini. For example, They can write 'vote_awp' in chat to start a vote for or against
			using awp, if they are allowed to execute this kind of vote.

			-You can set VFI_MAXNOMINATE. If enough map nominations are made, the multimap vote starts automatically.

	COMMANDS:
	admin_vote_cancel 				:cancels the current voting
	admin_vote_map <votetime>			:starts a single mapvote
	admin_vote_maps	<votetime>			:starts a multivote for the maps, which are stored in mapvote.ini
	admin_vote_mapadd <mapname> <votetime>		:adds the map to mapvote.ini (max. 8 maps)
	admin_vote_mapdel				:deletes entries in mapvote.ini
	admin_vote_maplist <opt. filename>		:display all maps which are stored in 'optional=filename'.ini. Default:"mapvote.ini"
	admin_vote_awp	<votetime>			:starts a vote for or against using awp (depends on what was voted before)
	admin_vote_chasecam <votetime>			:starts a vote for or against using chasecam (depends on what was voted before)
	admin_vote_extend <votetime>			:starts a vote for extendig the map
	admin_vote_ff <votetime>			:starts a vote for or against friendly fire (depends on what was voted before)
	admin_vote_gravity <number> <votetime>		:starts a vote for or against using low gravity (depends on what was voted before)
	admin_vote_pistols <votetime>			:starts a vote for or against using obly pistols (depends on what was voted before)
	admin_vote_mapchange <mapname> <votetime> 	:starts a vote for or against map.
	admin_vote_kickplayer <name> <votetime>		:starts a vote for or against kicking a player.
	admin_vote_slap <name> <votetime>		:starts a vote for or against slapping a player.
	admin_vote_slay <name> <votetime>		:starts a vote for or against slaying a player.
	admin_vote_ban <name> <votetime>		:starts a vote for or against banning a player.
	admin_vote_bury <name> <votetime>		:starts a vote for or against bury a player.
	admin_vote_sounds <0/1>				:turns vote-sounds off/on
	admin_vote_multimap				:players can make map suggestions and after 60 sec. the multivote starts.
	admin_vote_rr <votetime>			:starts a vote for or against restarting the map.

	---Changelog---

	04.03.03:	- Bugfix admin_vote_debug 'nomin'
			- Bugfix Display Vote Selection
			- Bugfix map restriction

	02.03.03:	- add VFI_MAXNOMINATE. If enough nominated maps are available, multimap vote starts automatically.

	28.02.03:	- all players can make votes if no admin is available and if VFI_PUBLIC is set to 1 in vault.ini
			  They are only allowed to start votes which are defined in 'publicvotes.ini'

	19.02.03:	- added in code: 'status' for votes.

	29.01.03:	- added allowsound() function. Use plugin_sdal_allowsounds!!
			- added maxextend
			- added map restriction. Last X played maps are restricted for being nominated again, if you set VFI_MAPRESTRICTION 1.
			- you can read every map*.ini file. command: admin_vote_maplist 'optional filename'. Default: 'mapvote.ini'

	04.01.03:	- added admin_vote_debug to look for settings
			- added an extra mapnominate.ini
			- added new helper functions: displayall and displayconsole

	22.12.02:	- announcing of the players vote decision. admin_vote_echo not of interest anylonger.

	12.12.02:	- deleted changings of 10.12.02: timer for automatic start of multimap deleted.
			- plugin created (plugin_sdal_time_manager), which can start the multimapvote automatically.This plugin contains logd

	10.12.02:	- added timer to start admin_vote_multimap automatically
			- votetime-duration of admin_vote_multimap could be set in vault.ini. Standard is 60 sec.
			- bugfix(i hope): now it should be shown the required votes for vote pass.
			- bugfix: admin_vote_sound should work now.

	27.11.02:	- changing admin_base

	06.11.02:	- admin_vote_rr
			- new helperfunction set_votesettings for prehandling the params
			- fixed Version 03.11.02 :-)

	03.11.02:	- bug fix in admin_vote_mapadd: check if map already exists in mapvote.ini
			- new optimized code structure :-) (added more helper-functions)
			- bug fix: In this plugin no votes are allowed after starting multivote.
			- bug fix: admin_vote_slap should work now
			- Mapchange: If there is also a map which can be extended, it will be displayed in question.

	02.11.02: 	- 'exetend' is removed from multivote. If currentmap = Nominated-Map = the map will be automatically extended

	01.11.02: 	- multimap function

	31.10.02: 	- adding kick, ban, slap and bury and using vault.ini for global plugin settings

	30.10.02: 	- new Code structure

	25.10.02: 	- sounds and single map vote included

	<25.10.02: 	- multimapvote-plugin and some single votes.
*/
#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "04.03.03 (edited for 1.6 14.10.03 Stills)";

#pragma dynamic 4096

#define voteend		0
#define votestart	1
#define ACCESS_VOTE_SETTINGS	256


/*Execute-Command-Array*/
/*REIHENFOLGE IM BESTEHENDEN EXECUTE-ARRAY MUSS IMMER DER DEFINE-REIHENFOLGE ENTSPRECHEN!!!!)*/
/*NEUE VOTE-BEFEHLE HINTEN DRAN HNGEN UND MAX_COMMANDS ENTSPRECHEND ERHHEN!!!*/
/*UND NEUEN DEFINE-1 FESTLEGEN.*/
#define MAX_COMMANDS 	13
#define AWP 		0
#define CHASECAM 	1
#define EXTEND		2
#define FF 		3
#define GRAVITY 	4
#define MAPCHANGE 	5
#define PISTOLS 	6
#define KICKPLAYER	7
#define SLAPPLAYER	8
#define SLAYPLAYER	9
#define BANPLAYER	10
#define BURYPLAYER	11
#define RESTARTROUND	12

new voteidentify=-1;
new Execute[MAX_COMMANDS][]=	{{"awp"},{"chasecam"},{"extend"},
				{"ff"},{"gravity"},{"map"},
				{"pistols"},{"kick"},{"slap"},{"slay"},{"ban"},{"bury"},{"rr"}};

/*Fr AWP, chasecam, ff, gravity, pistols*/
new ValueStatus[MAX_COMMANDS];

/*Vote Sounds und Vault.ini Settings*/
new soundsallowed;
new Bell[MAX_TEXT_LENGTH];
new VoteNow[MAX_TEXT_LENGTH];
new VoteFailed[MAX_TEXT_LENGTH];
new VotePassed[MAX_TEXT_LENGTH];
new allowpublic;
new maxnominate;
new maprestriction;
/*10.12.02:Fr das Mapnominating--Warnings*/
new votetimeorig;
new votetime;

/*--- VOTE-CANCEL-VALUE---*/
new vote_canceled=0;
new votestarted=0;

/*--- MAPS AND TIME-Values for mapvoting---*/
#define MAX_NOMINATIONS 9
new FileDir[MAX_TEXT_LENGTH]="addons/adminmod/config/vfi/";
new MAPS[MAX_TEXT_LENGTH]="mapvote.ini";
new NOMINATEMAPS[MAX_TEXT_LENGTH]="mapnominate.ini";
new NominatedMaps[MAX_NOMINATIONS][MAX_NAME_LENGTH];
new MapCandidates[MAX_PLAYERS][MAX_NAME_LENGTH];
new multimapstart;
new nominate;

/*29.01.03: Last Maps, die von Spielern nicht vorgeschlagen werden drfen. Default sind 3 Maps.*/
#define anzahl 5
new LastMaps[anzahl][MAX_NAME_LENGTH];
new LastMapsINI[MAX_TEXT_LENGTH]="lastmaps.ini";
new lastmapsize;

/*--- SERVER_CVAR mp_timelimit ---*/
new origTimelimit;

/*---SERVER_CVAR of VOTE-ECHO AND VOTE-DURATION---*/
new OrigVoteDuration[MAX_NUMBER_LENGTH];

/*---STATUS-VALUES---*/
new BuyPlayer[MAX_PLAYERS];
/*29.01.03: extend restriction for players*/
new origextend;


/* Public-Votes are allowed*/
new PUBLICVOTES[MAX_TEXT_LENGTH]="publicvote.ini";

/*--------------------------------- DIE ADMINMOD-FUNKTIONEN -------------------------*/

/*--- DIE VOTE-HAUPT-FUNKTION ---*/
public admin_vote(HLCommand,HLData,HLUserName,UserIndex) {
	if(multimapstart==0){
		new Command[MAX_COMMAND_LENGTH];
		new Data[MAX_DATA_LENGTH];
		new User[MAX_NAME_LENGTH];
		new Dummy[6];
		new VoteCommand[30];

		convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,User,MAX_NAME_LENGTH);

		if (vote_allowed()!=1) {
			displayconsole("","Vote ist zur Zeit nicht erlaubt.","");
			return PLUGIN_HANDLED;
		}

		strsplit(Command,"_",Dummy,6,Dummy,6,VoteCommand,30);

		for(voteidentify=0; voteidentify < MAX_COMMANDS; voteidentify++){
			if(strcmp(Execute[voteidentify],VoteCommand)==0){
				set_votesettings(Data,voteidentify,User);
				break;
			}
		}
	}else{
		displayconsole("","Zur Zeit kein Vote moeglich! Multimap-Vote wurde gestartet!","");
	}
	return PLUGIN_HANDLED;
}

public admin_vote_cancel(HLCommand,HLData,HLUserName,UserIndex){
	/*10.12.02:Multimapstart ist nun auch mit admin_vote_cancel sofort abbrechbar*/
	if (vote_allowed()==1 && multimapstart == 0) {
		displayconsole("","Ein Vote ist zur Zeit NICHT im Gange!","");
		return PLUGIN_HANDLED;
	}
	vote_canceled=1;
	reset_votesettings();
	displayconsole("","Der aktuelle Vote oder das Mapnominating wurde aufgehoben!","");
	return PLUGIN_HANDLED;
}

/*DEBUG-FUNKTION*/
public admin_vote_debug(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new VoteCommands[MAX_TEXT_LENGTH];
	new File[MAX_TEXT_LENGTH];
	new Playername[MAX_NAME_LENGTH];
	new i;
	new sid;
	new wid;
	new dead;
	new team;
	new iLine;
	new maxplayers=maxplayercount();

	convert_string(HLData,Data,MAX_DATA_LENGTH);

	selfmessage("");
	selfmessage("----------- PLUGIN VOTE-FOR-IT DEBUG ----------");
	if(strcmp(Data,"vault")==0){
		selfmessage("----------- VALUES IN VAULT.INI -----------");
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_VOTEWARN: %s", Bell);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_VOTENOW: %s", VoteNow);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_VOTEPASSED: %s", VotePassed);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_VOTEFAILED: %s", VotePassed);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_SOUNDSALLOWED: %i", soundsallowed);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_TIMETONOMINATE: %i", votetimeorig);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_PUBLIC: %i", allowpublic);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_MAXNOMINATIONS: %i", maxnominate);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_MAPRESTRICTION: %i", maprestriction);
		selfmessage(Text);
	}else if(strcmp(Data,"server")==0){
		selfmessage("------------- SERVER SETTINGS: ---------------");
		snprintf(Text,MAX_TEXT_LENGTH,"orig. timelimit: %i", origTimelimit);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"orig. vote duration: %s", OrigVoteDuration);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"orig. max-extend: %i", origextend);
		selfmessage(Text);
	}else if(strcmp(Data,"game")==0){
		selfmessage("-------------- GAME SETTINGS: ----------------");
		snprintf(Text,MAX_TEXT_LENGTH,"friendlyfire: %i", ValueStatus[FF]);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"chasecam: %i", ValueStatus[CHASECAM]);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"pistols only: %i", ValueStatus[PISTOLS]);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"awp disabled: %i", ValueStatus[AWP]);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"map maxextend: %i", ValueStatus[EXTEND]);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"gravity: %i", ValueStatus[GRAVITY]);
		selfmessage(Text);
	}else if(strcmp(Data,"vote")==0){
		selfmessage("--------------- VOTE SETTINGS: ----------------");
		snprintf(Text,MAX_TEXT_LENGTH,"Current Vote_ID: %i", voteidentify);
		selfmessage(Text);
		if(voteidentify!=-1){
			snprintf(Text,MAX_TEXT_LENGTH,"Current Vote_Command: %s", Execute[voteidentify]);

		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"Current Vote_Command: Kein Vote ist aktiv!");
		}
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"Current Vote-Status: vote canceled: %i", vote_canceled);
		selfmessage(Text);
	}else if(strcmp(Data,"nomin")==0){
		selfmessage("---------- MAP NOMINATINATION SETTINGS: ---------------");
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_MAXNOMINATIONS: %i", maxnominate);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_TIMETONOMINATE: %i", votetimeorig);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"multimapstart: %i", multimapstart);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"remaining nominate time: %i", votetime);
		selfmessage(Text);
		selfmessage("-CURRENTLY NOMINATED MAPS:-");
		for(i=1;i<=maxplayers;i++){
			if(playerinfo(i,Playername,MAX_NAME_LENGTH,sid,wid,team,dead)){
				snprintf(Text,MAX_TEXT_LENGTH,"%s: %s", Playername,MapCandidates[i]);
				selfmessage(Text);
			}
		}
	}else if(strcmp(Data,"restr")==0){
		selfmessage("-------------- MAP RESTRICTION SETTINGS -----------------");
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_MAPRESTRICTION: %i", maprestriction);
		selfmessage(Text);
		selfmessage("Last played maps:");
		for(i=1;i<anzahl;i++){
			snprintf(Text,MAX_TEXT_LENGTH,"%i. %s",i, LastMaps[i]);
			selfmessage(Text);
		}
	}else if(strcmp(Data,"public")==0){
		selfmessage("-------------- PUBLIC VOTE SETTINGS -----------------");
		snprintf(Text,MAX_TEXT_LENGTH,"VFI_PUBLIC: %i", allowpublic);
		selfmessage(Text);
		selfmessage("Allowed public votes:");
		snprintf(File,MAX_TEXT_LENGTH,"%s%s",FileDir,PUBLICVOTES);
		iLine=filesize(File);
		for(i=1;i<=iLine;i++){
			readfile(File,VoteCommands,i,MAX_TEXT_LENGTH);
			snprintf(Text,MAX_TEXT_LENGTH,"%i. %s",i, VoteCommands);
			selfmessage(Text);
		}
	}else{
		selfmessage("Es gibt folgende Debug-Modi: (admin_vote_debug XXX)");
		selfmessage("vault:^t Zeigt Dir alle vault.ini Eintraege.");
		selfmessage("server:^t Zeigt Dir alle original Server Eintraege.");
		selfmessage("game:^t Zeigt Dir alle Eintraege an, die zur Zeit aktiv sind.(z.B. 1=aktiv, 0=inaktiv)");
		selfmessage("vote:^t Zeigt Dir alle Vote-Eintraege an, die gerade laufen bzw. aktiv sind.");
		selfmessage("nomin:^t Zeigt Dir alle Eintraege an, die zur Mapnominierung gehoeren.");
		selfmessage("restr:^t Zeigt Dir alle Eintraege an, die zur Maprestriktion gehoeren.");
		selfmessage("public:^t Zeigt Dir alle Eintraege an, die zum Public-Vote-System gehoeren.");
		selfmessage("");
		selfmessage("Um das Plugin manuell zu konfigurieren, stehen folgende Befehle zur Verfuegung:");
		selfmessage("(Man braucht den Rechtelevel 256 dafuer)");
		selfmessage("-admin_vote_mapadd <mapname> <opt.filename> :");
		selfmessage(" Damit kannst Du Maps zur Datei hinzufuegen. Default:mapvote.ini");
		selfmessage("-admin_vote_mapdel <opt.filename> :");
		selfmessage(" Damit leerst Du die Datei. Default:mapvote.ini");
		selfmessage("-admin_vote_maplist <opt. filename> :");
		selfmessage(" Damit kann man sich ansehen, was in der Datei steht. Default:mapvote.ini");
		selfmessage("-admin_vote_sound <0/1>:");
		selfmessage(" Damit koennen alle Sounds generell ab/angeschaltet werden.");
		selfmessage("-admin_vote_public <0/1>:");
		selfmessage(" Legt fest, ob es ALLEN erlaubt ist, Votes zu starten, die in der publicvote.ini festgelegt sind.");
		selfmessage(" Sie duerfen aber nur dann die Votes benutzen, wenn kein Admin anwesend ist.");
		selfmessage("-admin_vote_maxnom <0/max.8>:");
		selfmessage(" Damit beginnt ein multimap-vote automatisch, wenn entsprechend genug");
		selfmessage(" Vorschlaege gemacht wurden. 0=Aus.");
		selfmessage("-admin_vote_restrict  <0/1>:");
		selfmessage(" Damit duerfen die letzten 4 gespielten Maps nicht mehr nominiert werden. 0=Aus.");
	}
	selfmessage("-----------------------------------------------------------");
	return PLUGIN_HANDLED;
}

public admin_vote_maps(HLCommand,HLData,HLUserName,UserIndex) {
	if(multimapstart==0){
		new Data[MAX_DATA_LENGTH];
		new VoteTime[MAX_NUMBER_LENGTH];
		new voteduration;

		if (vote_allowed()!=1) {
			displayconsole("","Vote ist zur Zeit nicht erlaubt","");
			return PLUGIN_HANDLED;
		}

		convert_string(HLData,Data,MAX_DATA_LENGTH);

		voteduration=strtonum(Data);
		if(voteduration<=0){
			strcpy(VoteTime,OrigVoteDuration,3);
		}
		setstrvar("amv_vote_duration",VoteTime);
		votemaps(MAPS);
	}else{
		displayconsole("","Zur Zeit kein Vote moeglich! Multimap-Vote wurde gestartet!","");
	}
	return PLUGIN_HANDLED;
}

public admin_vote_mapadd(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Map[MAX_NAME_LENGTH];
	new FileName[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strbreak(Data,Map,FileName,MAX_DATA_LENGTH);
	if(strlen(FileName)!=0){
		mapadd(FileName,Map);
	}else{
		mapadd(MAPS,Map);
	}
	return PLUGIN_HANDLED;
}

public admin_vote_mapdel(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new i;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if(strlen(Data)!=0){
		if(strcmp(Data,LastMapsINI)==0){
			for(i=1;i<anzahl;i++){
				strinit(LastMaps[i]);
			}
		}
		mapdel(Data);
	}else{
		mapdel(MAPS);
	}
	return PLUGIN_HANDLED;
}

public admin_vote_maplist(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if(strlen(Data)==0){
		mapread(MAPS,1);
	}else{
		mapread(Data,1);
	}
	return PLUGIN_HANDLED;
}

public admin_vote_restrict(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new iData;
	convert_string(HLData,Data,MAX_DATA_LENGTH);

	iData=strtonum(Data);
	if(iData==0){
		set_vaultnumdata("VFI_MAPRESTRICTION",0);
		maprestriction=0;
		displayconsole("","Map restriction is turned off!","");
	}else{
		set_vaultnumdata("VFI_MAPRESTRICTION",1);
		maprestriction=1;
		displayconsole("","Map restriction is turned on!","");
	}
	return PLUGIN_HANDLED;
}

public admin_vote_maxnom(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new iData;
	convert_string(HLData,Data,MAX_DATA_LENGTH);

	iData=strtonum(Data);
	if(iData==0){
		set_vaultdata("VFI_MAXNOMINATIONS","0");
		maxnominate=0;
		displayconsole("","Max Nominations is turned off!","");
	}else{
		set_vaultnumdata("VFI_MAXNOMINATIONS",iData);
		maxnominate=iData;
		displayconsole("","Max Nominations are set to",Data);
	}
	return PLUGIN_HANDLED;
}

public admin_vote_multimap(HLCommand,HLData,HLUserName,UserIndex) {
	set_timer("vote_multimap",1,0);
	return PLUGIN_HANDLED;
}

public admin_vote_public(HLCommand,HLData,HLUserName,UserIndex) {
	new PublicVote[3];
	convert_string(HLData,PublicVote,3);
	if(PublicVote[0]=='1'){
		set_vaultdata("VFI_PUBLIC","1");
		allowpublic=1;
		displayconsole("","All players can make votes,","which are set in publicvote.ini");
	}else{
		set_vaultdata("VFI_PUBLIC","0");
		allowpublic=0;
		displayconsole("","Votes for nonadmins","are disabled!");
	}
	return PLUGIN_HANDLED;
}

public admin_vote_sound(HLCommand,HLData,HLUserName,UserIndex){
	new Sounds[3];
	convert_string(HLData,Sounds,3);
	if(Sounds[0]=='1'){
		set_vaultdata("VFI_SOUNDSALLOWED","1");
		soundsallowed=1;
		displayconsole("","Vote-Sounds are enabled","");
	}else{
		set_vaultdata("VFI_SOUNDSALLOWED","0");
		soundsallowed=0;
		displayconsole("","Vote-Sounds are disabled","");
	}
	return PLUGIN_HANDLED;
}

/*--------------------------------- DIE HILFS-FUNKTIONEN -------------------------*/

allowsound(User[]){
	new Key[]="am_sound";
	new Info[MAX_NUMBER_LENGTH];
	new iInfo;
	new Authid[MAX_AUTHID_LENGTH];
	get_userAuthID(User,Authid,MAX_AUTHID_LENGTH);
	if(strcmp(Authid,"BOT")!=0){
		get_userinfo(User,Key,Info,MAX_NUMBER_LENGTH);
		iInfo=strtonum(Info);
		if(strlen(Info)==0){/*damit wird automatisch immer der Sound auf 1 gesetzt,wenn kein setinfo vorhanden, bis 'stop' eingegeben wird*/
			return 1;
		}
		if(iInfo>=1){
			return 1;
		}else{
			return 0;
		}
		return 0;
	}
	return 0;
}

check_admin(){
	new Player[MAX_NAME_LENGTH];
	new i;
	new maxplayers=maxplayercount();
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH)){
			if(access(2,Player)==1){
				return 1;
				break;
			}
		}
	}
	return 0;
}

checkplayer(Player[]){
	new Text[MAX_TEXT_LENGTH];

	if(check_user(Player)==1){
		if(check_immunity(Player)!=0) {
			snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't vote against %s, you silly bear.", Player);
			displayconsole("",Text,"");
			reset_votesettings();
			return 0;
		}else{
			return 1;
		}
	}else{
		displayconsole("Unrecognized user name:",Player,"");
		reset_votesettings();
		return 0;
	}
	return 0;
}
displayall(Text[]){
	centersay(Text,12,100,140,255);
	say(Text);
}

displayconsole(Text1[],Text2[],Text3[]){
	selfmessage("");
	selfmessage("-- PLUGIN VOTE FOR IT --");
	selfmessage("");
	selfmessage(Text1);
	selfmessage(Text2);
	selfmessage(Text3);
	selfmessage("-----------------------------");
	selfmessage("");
}

mapadd(FileName[],MapName[]) {
	new Text[MAX_TEXT_LENGTH];
	new Msg[MAX_TEXT_LENGTH];
	new Map[MAX_DATA_LENGTH];
	new File[MAX_TEXT_LENGTH];
	new iLine;
	new i;
	snprintf(File,MAX_TEXT_LENGTH,"%s%s",FileDir,FileName);
	if(fileexists(File)){
		iLine=filesize(File);
		if(iLine >= 8){
			displayconsole("Es sind schon max.8 Maps angelegt","Man muss admin_vote_mapdel ausfuehren, um neue Maps anzulegen.","");
		}else{
			if(valid_map(MapName) != 1) {
				snprintf(Msg,MAX_TEXT_LENGTH,"Die Map %s ist nicht gueltig.",MapName);
				displayconsole("",Msg,"");
			}else{
				for(i=1;i<=iLine;i++){
					readfile(File,Map,i,MAX_NAME_LENGTH);
					if(strcmp(Map,MapName)==0){
						displayconsole("Map ist bereits in der",FileName,"angelegt!!!");
						return PLUGIN_CONTINUE;
						break;
					}
				}
				mapwrite(FileName,MapName,1);
			}
		}
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"Konnte %s nicht finden!",FileName);
		displayconsole("",Text,"");
	}
	return PLUGIN_CONTINUE;
}

mapdel(FileName[]){
	new Text[MAX_TEXT_LENGTH];
	new File[MAX_TEXT_LENGTH];
	snprintf(File,MAX_TEXT_LENGTH,"%s%s",FileDir,FileName);
	if(fileexists(File)){
		resetfile(File);
		snprintf(Text,MAX_TEXT_LENGTH,"Der Inhalt von %s wurde geloescht!",FileName);
		displayconsole("",Text,"");
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"Konnte %s nicht finden!",FileName);
		displayconsole("",Text,"");
	}
	return PLUGIN_CONTINUE;
}

/*29.01.03: Um Position erweitert! Wird noch nicht wichtig sein, aber wer wei.*/
mapwrite(FileName[],MapName[],show){
	new Text[MAX_TEXT_LENGTH];
	new File[MAX_TEXT_LENGTH];
	snprintf(File,MAX_TEXT_LENGTH,"%s%s",FileDir,FileName);
	if(fileexists(File)){
		writefile(File,MapName,-1);
		if(show==1){
			snprintf(Text,MAX_TEXT_LENGTH,"Map %s in %s angelegt",MapName,FileName);
			displayconsole("",Text,"");
		}
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"Konnte %s nicht finden!",FileName);
		displayconsole("",Text,"");
	}
	return PLUGIN_CONTINUE;
}

/*29.01.03: Mapread*/
mapread(FileName[],show){
	/*show = 0 gilt nur fr die Map-Restriction der lastmaps.ini, wenn bei plugin_init die zuletzt gespielten Maps eingelesen werden.*/
	new Text[MAX_TEXT_LENGTH];
	new Maps[MAX_NAME_LENGTH];
	new File[MAX_TEXT_LENGTH];
	snprintf(File,MAX_TEXT_LENGTH,"%s%s",FileDir,FileName);
	new i;
	new iLine;
	if(fileexists(File)){
		iLine=filesize(File);
		if(show==0){
			if(iLine>=anzahl){
				lastmapsize=anzahl;
				iLine=anzahl;
			}else{
				lastmapsize=iLine;
			}
		}

		if(iLine==0){
			snprintf(Text,MAX_TEXT_LENGTH,"Keine Maps in %s angelegt!",FileName);
			displayconsole("",Text,"");
		}else{
			if(show==1){
				snprintf(Text,MAX_TEXT_LENGTH,"File: %s",FileName);
				selfmessage("");
				selfmessage("-- VOTE FOR IT --");
				selfmessage(Text);
				selfmessage("");
			}
			for(i=1;i<=iLine;i++){
				readfile(File,Maps,i,MAX_NAME_LENGTH);
				if(show==1){
					snprintf(Maps,MAX_NAME_LENGTH,"%i.%s",i,Maps);
					selfmessage(Maps);
				}else{
					strcpy(LastMaps[i],Maps,MAX_NAME_LENGTH);
				}
			}
			if(show==1){
				selfmessage("");
				selfmessage("------------------------");
			}
		}
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"Konnte %s nicht finden!",FileName);
		displayconsole("",Text,"");
	}
	return PLUGIN_CONTINUE;
}

reset_votesettings(){
	new i;
	for(i=0;i<=MAX_PLAYERS;i++){
		BuyPlayer[i]=0;
	}
	setstrvar("amv_vote_duration",OrigVoteDuration);
	multimapstart=0;
	votetime=votetimeorig;
	voteidentify=-1;
}

set_votesettings(VoteData[],voteid,User[]){
	new VoteTime[MAX_NUMBER_LENGTH];
	new VoteContent[MAX_DATA_LENGTH];
	new voteduration;
	new x=0;
	/*x beinhalted, wieviele Parameter die Funktion neben der VoteTime habe kann*/
	/*12.12.02: restartround kann man keinen Parameter mehr geben. Ist also immer 1sek.*/
	switch(voteid){
		case GRAVITY: 		x=1;
		case MAPCHANGE: 	x=1;
		case KICKPLAYER: 	x=1;
		case SLAPPLAYER: 	x=1;
		case BANPLAYER:		x=1;
		case BURYPLAYER:	x=1;
		default: 		x=0;
	}
	if(x==1){
		strbreak(VoteData,VoteContent,VoteTime,MAX_DATA_LENGTH);
	}else{
		strcpy(VoteTime,VoteContent,MAX_NUMBER_LENGTH);
	}
	if(x==1 && strlen(VoteContent)==0){
		displayconsole("","Der Vote hat keinen Inhalt! Abbruch!","");
		messageex(User,"Der Vote hat keinen Inhalt! Abbruch!",print_chat);
	}else{
		voteduration=strtonum(VoteTime);
		if(voteduration<=0){
			strcpy(VoteTime,OrigVoteDuration,MAX_NUMBER_LENGTH);
		}
		setstrvar("amv_vote_duration",VoteTime);
		votestarted=1;
		switch(voteid){
			case AWP: 		awp(votestart);
			case CHASECAM: 		chasecam(votestart);
			case EXTEND: 		extend(votestart);
			case FF: 		ff(votestart);
			case GRAVITY: 		gravity(VoteContent,votestart);
			case MAPCHANGE:		mapchange(VoteContent,votestart);
			case PISTOLS:		pistols(votestart);
			case KICKPLAYER: 	kickplayer(VoteContent,votestart);
			case SLAPPLAYER: 	slapplayer(VoteContent,votestart);
			case SLAYPLAYER: 	slayplayer(VoteContent,votestart);
			case BANPLAYER: 	banplayer(VoteContent,votestart);
			case BURYPLAYER: 	buryplayer(VoteContent,votestart);
			case RESTARTROUND: 	restart(votestart);
		}
	}
}

sound_all(Sound[]){
	if(soundsallowed==1){
		new Name[MAX_NAME_LENGTH];
		new maxplayers = maxplayercount();
		new i;
		new dummy1;

		for(i=1; i<=maxplayers; i++ ){
			if( playerinfo(i, Name, MAX_NAME_LENGTH,dummy1,dummy1,dummy1,dummy1) ){
				if(allowsound(Name)==1){
					playsound(Name,Sound);
				}
			}
		}
	}
}

vote_public(Content[],User[]){
	new Text[MAX_TEXT_LENGTH];
	new Command[MAX_TEXT_LENGTH];
	new Param[MAX_TEXT_LENGTH];
	new i;
	new x;
	strbreak(Content,Command,Param,MAX_TEXT_LENGTH);
	for(i=0;i<MAX_COMMANDS;i++){
		if(strcmp(Command,Execute[i])==0){
			voteidentify=i;
			set_votesettings(Param,voteidentify,User);
			x=1;
			break;
		}
	}
	if(!x){
		snprintf(Text,MAX_TEXT_LENGTH,"Konnte vote_%s nicht ausfuehren!",Content);
		messageex(User,Text,print_chat);
	}
}


/*--------------------------------- DIE VOTE - UNTERFUNKTIONEN -------------------------*/

awp(status){
	new Question[MAX_TEXT_LENGTH];
	if(status==1){
		if(ValueStatus[PISTOLS]==1){
			displayconsole("","Macht keinen Sinn, da sowieso nur Pistolen erlaubt sind!","");
		}else{
			if(ValueStatus[AWP]==0){
				strcpy(Question,"AWP verbieten?^n",MAX_TEXT_LENGTH);
			}else{
				strcpy(Question,"AWP erlauben?^n",MAX_TEXT_LENGTH);
			}
			sound_all(VoteNow);
			vote(Question,"JA","NEIN","NormVote","");
		}
	/*!!!!Hier ist die Aenderung fuer CS 1.6 und das Plugin_CS by SDal!!!!*/
	}else{
		snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat ergeben,^ndass die AWP");
		if(ValueStatus[AWP]==0){
			plugin_exec("admin_restrict","awp");
			ValueStatus[AWP]=1;
			snprintf(Question,MAX_TEXT_LENGTH,"%s verboten ist!^n",Question);
		}else{
			plugin_exec("admin_unrestrict","awp");
			ValueStatus[AWP]=0;
			ValueStatus[PISTOLS]=0;
			snprintf(Question,MAX_TEXT_LENGTH,"%s erlaubt ist!^n",Question);
		}
		displayall(Question);
	}
}

banplayer(VoteContent[],status){
	new Question[MAX_TEXT_LENGTH];
	new Target[MAX_NAME_LENGTH];
	if(status==1){
		get_username( VoteContent, Target, MAX_NAME_LENGTH );
		if(checkplayer(Target)==1){
			snprintf(Question,MAX_TEXT_LENGTH,"Soll %s gebannt werden ?^n",Target);
			vote(Question,"JA","NEIN","NormVote",Target);
			sound_all(VoteNow);
		}
	}else{
		snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat entschieden,^ndass %s verbannt wird!",VoteContent);
		displayall(Question);
		plugin_exec("admin_ban",VoteContent);
	}
}

buryplayer(VoteContent[],status){
	new Question[MAX_TEXT_LENGTH];
	new Target[MAX_NAME_LENGTH];
	if(status==1){
		get_username( VoteContent, Target, MAX_NAME_LENGTH );
		if(checkplayer(Target)==1){
			snprintf(Question,MAX_TEXT_LENGTH,"Soll %s eingegraben werden ?^n",Target);
			vote(Question,"JA","NEIN","NormVote",Target);
			sound_all(VoteNow);
		}
	}else{
		snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat entschieden,^ndass %s eingegraben wird!",VoteContent);
		displayall(Question);
		plugin_exec("admin_bury",VoteContent);
	}
}

chasecam(status){
	new Question[MAX_TEXT_LENGTH];
	if(status==1){
		if(ValueStatus[CHASECAM]==0){
			strcpy(Question,"Chasecam anschalten? ^n",MAX_TEXT_LENGTH);
		}else{
			strcpy(Question,"Chasecam ausschalten? ^n",MAX_TEXT_LENGTH);
		}
		vote(Question,"JA","NEIN","NormVote","");
		sound_all(VoteNow);
	}else{
		if(ValueStatus[CHASECAM]==0){
			snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat ergeben,^ndass Chasecam an ist!");
			ValueStatus[CHASECAM]=1;
			exec("mp_forcechasecam 1");
		}else{
			snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat ergeben,^ndass Chasecam aus ist!");
			ValueStatus[CHASECAM]=0;
			exec("mp_forcechasecam 0");
		}
		displayall(Question);
	}
}
extend(status){
	if(status==1){
		vote("Die Map weiterspielen?","JA","NEIN","NormVote","");
		sound_all(VoteNow);
	}else{
		new Text[MAX_DATA_LENGTH];
		new Timelimit = 0;
		Timelimit = getvar("mp_timelimit");
		Timelimit += origTimelimit;
		ValueStatus[EXTEND]+=1;
		snprintf(Text, MAX_DATA_LENGTH, "mp_timelimit %i", Timelimit);
	  	exec(Text);
		snprintf(Text,MAX_DATA_LENGTH,"Der Vote hat ergeben,^ndass die Map um %i min. verlaengert wird",origTimelimit);
		displayall(Text);
	}
}

ff(status){
	new Question[MAX_TEXT_LENGTH];
	if(status==1){
		if(ValueStatus[FF]==0){
			strcpy(Question,"Friendly Fire anschalten? ^n",MAX_TEXT_LENGTH);
		}else{
			strcpy(Question,"Friendly Fire ausschalten? ^n",MAX_TEXT_LENGTH);
		}
		vote(Question,"JA","NEIN","NormVote","");
		sound_all(VoteNow);
	}else{
		if(ValueStatus[FF]==0){
			snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat ergeben,^ndass Friendly Fire an ist!");
			ValueStatus[FF]=1;
			exec("mp_friendlyfire 1");
		}else{
			snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat ergeben,^ndass Friendly Fire aus ist!");
			ValueStatus[FF]=0;
			exec("mp_friendlyfire 0");
		}
		displayall(Question);
	}
}

gravity(VoteContent[],status){
	new Question[MAX_TEXT_LENGTH];
	if(status==1){
		new iVoteContent;
		iVoteContent=strtonum(VoteContent);
		if(iVoteContent<=0){
			displayconsole("","Gravity-Wert muss groesser 0 sein!","");
		}else{
			snprintf(Question,MAX_TEXT_LENGTH,"Gravity auf %s einstellen? ^n",VoteContent);
			vote(Question,"JA","NEIN","NormVote",VoteContent);
			sound_all(VoteNow);
		}
	}else{
		new ExecCommand[MAX_DATA_LENGTH];
		snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat ergeben,^ndass die GRAVITY auf %s eingestellt wird!",VoteContent);
		displayall(Question);
		snprintf(ExecCommand,MAX_DATA_LENGTH,"sv_gravity %s", VoteContent);
		exec(ExecCommand);
		ValueStatus[GRAVITY]=strtonum(VoteContent);
	}
}

kickplayer(VoteContent[],status){
	new Question[MAX_TEXT_LENGTH];
	new Target[MAX_NAME_LENGTH];
	if(status==1){
		get_username( VoteContent, Target, MAX_NAME_LENGTH );
		if(checkplayer(Target)==1){
			snprintf(Question,MAX_TEXT_LENGTH,"Soll %s gekicked werden ?^n",Target);
			vote(Question,"JA","NEIN","NormVote",Target);
			sound_all(VoteNow);
		}
	}else{
		snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat entschieden,^ndass %s entfernt wird!",VoteContent);
		displayall(Question);
		plugin_exec("admin_kick",VoteContent);
	}
}

mapchange(VoteContent[],status){
	new Question[MAX_TEXT_LENGTH];
	new Map[MAX_NAME_LENGTH];
	new i;
	currentmap(Map,MAX_NAME_LENGTH);
	if(status==1){
		if(valid_map(VoteContent) == 1){
			voteidentify=5;
			if(strcmp(Map,VoteContent)==0){
				snprintf(Question,MAX_TEXT_LENGTH,"Soll %s verlaengert werden?^n",VoteContent);
			}else{
				snprintf(Question,MAX_TEXT_LENGTH,"Mapwechsel zu: %s?^n",VoteContent);
			}
			vote(Question,"JA","NEIN","NormVote",VoteContent);
			sound_all(VoteNow);
		}else{
			snprintf(Question,MAX_TEXT_LENGTH,"Die Map %s ist nicht gueltig.",VoteContent);
			displayconsole("",Question,"");
			reset_votesettings();
		}
	}else{
		if(strcmp(VoteContent,Map)==0){
			extend(voteend);
		}else{
			snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat entschieden,^ndass zu %s gewechselt wird!",VoteContent);
			displayall(Question);
			if(lastmapsize<anzahl-1){
				mapwrite(LastMapsINI,Map,0);
			}else{
				mapdel(LastMapsINI);
				for(i=2;i<anzahl;i++){
					mapwrite(LastMapsINI,LastMaps[i],0);
				}
				mapwrite(LastMapsINI,Map,0);
			}
			changelevel(VoteContent,3);
		}
	}
}

restart(status){
	new Question[MAX_TEXT_LENGTH];
	if(status==1){
		snprintf(Question,MAX_TEXT_LENGTH,"Restart map?^n");
		vote(Question,"JA","NEIN","NormVote","");
		sound_all(VoteNow);
	}else{
		snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat entschieden,^ndass die Runde neu gestartet wird!");
		displayall(Question);
		setstrvar("sv_restartround","1");
	}
}


pistols(status){
	new Question[MAX_TEXT_LENGTH];
	if(status==1){
		if(ValueStatus[PISTOLS]==0){
			strcpy(Question,"Nur mit Pistolen spielen? ^n",MAX_TEXT_LENGTH);
		}else{
			strcpy(Question,"Wieder alle Waffen erlauben? ^n",MAX_TEXT_LENGTH);
		}
		vote(Question,"JA","NEIN","NormVote","");
		sound_all(VoteNow);
		/*!!!!Hier nun die Aenderung fuer die Pistolenvotes bei vorausgesetztem plugin_CS by SDal!!!!*/
	}else{
		if(ValueStatus[PISTOLS]==0){
			snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat ergeben,^ndass nur Pistolen erlaubt sind!");
			ValueStatus[PISTOLS]=1;
			ValueStatus[AWP]=0;
			plugin_exec("admin_restrictmenu","2");
			plugin_exec("admin_restrictmenu","3");
			plugin_exec("admin_restrictmenu","4");
			plugin_exec("admin_restrictmenu","5");
		}else{
			snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat ergeben,^ndass alle Waffen erlaubt sind!");
			ValueStatus[PISTOLS]=0;
			ValueStatus[AWP]=0;
			plugin_exec("admin_unrestrictmenu","2");
			plugin_exec("admin_unrestrictmenu","3");
			plugin_exec("admin_unrestrictmenu","4");
			plugin_exec("admin_unrestrictmenu","5");
			plugin_exec("admin_restrict","restore");
		}
		displayall(Question);
	}
}

slapplayer(VoteContent[],status){
	new Question[MAX_TEXT_LENGTH];
	new Target[MAX_NAME_LENGTH];
	if(status==1){
		get_username( VoteContent, Target, MAX_NAME_LENGTH );
		if(checkplayer(Target)==1){
			snprintf(Question,MAX_TEXT_LENGTH,"Soll %s geslappt werden ?^n",Target);
			vote(Question,"JA","NEIN","NormVote",Target);
			sound_all(VoteNow);
		}
	}else{
		snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat entschieden,^ndass %s geschlagen wird!",VoteContent);
		displayall(Question);
		plugin_exec("admin_slap",VoteContent);
	}
}

slayplayer(VoteContent[],status){
	new Question[MAX_TEXT_LENGTH];
	new Target[MAX_NAME_LENGTH];
	if(status==1){
		get_username( VoteContent, Target, MAX_NAME_LENGTH );
		if(checkplayer(Target)==1){
			snprintf(Question,MAX_TEXT_LENGTH,"Soll %s geslayed werden ?^n",Target);
			vote(Question,"JA","NEIN","NormVote",Target);
			sound_all(VoteNow);
		}
	}else{
		snprintf(Question,MAX_TEXT_LENGTH,"Der Vote hat entschieden,^ndass %s getoetet wird!",VoteContent);
		displayall(Question);
		plugin_exec("admin_slay",VoteContent);
	}
}


/*---- FUNKTION FR DAS MULTI-MAP-VOTING ----*/
votemaps(FileName[]){
	new Text[MAX_TEXT_LENGTH];
	new msg[MAX_TEXT_LENGTH] = "Wollt ihr einen Mapwechsel^n";
	new msgextend[MAX_TEXT_LENGTH];
	new Map[MAX_NAME_LENGTH];
	new File[MAX_TEXT_LENGTH];
	new i;
	new iLine;
	strcpy(File,FileDir,MAX_TEXT_LENGTH);
	strcat(File,FileName,MAX_TEXT_LENGTH);
	currentmap(Map,MAX_NAME_LENGTH);
	iLine=filesize(File);

	if(iLine>8){
		iLine=8;
	}
	if(iLine>0){
		sound_all(VoteNow);
		for(i=1;i<=iLine;i++){
			readfile(File,NominatedMaps[i],i,MAX_NAME_LENGTH);
			if(strcmp(Map,NominatedMaps[i])==0){
				snprintf(msgextend,MAX_TEXT_LENGTH,"oder %s verlaengern^n",NominatedMaps[i]);
				strcat(msg,msgextend,MAX_TEXT_LENGTH);
			}
		}
		multimapstart=1;
		votestarted=1;
		switch(i-1){
			case 1:{
				mapchange(NominatedMaps[1],votestart);
				multimapstart=0;
			}
			case 2: vote(msg,NominatedMaps[1],NominatedMaps[2],"HVoteMap","");
			case 3: vote(msg,NominatedMaps[1],NominatedMaps[2],NominatedMaps[3],"HVoteMap","");
			case 4: vote(msg,NominatedMaps[1],NominatedMaps[2],NominatedMaps[3],NominatedMaps[4],"HVoteMap","");
			case 5: vote(msg,NominatedMaps[1],NominatedMaps[2],NominatedMaps[3],NominatedMaps[4],NominatedMaps[5],"HVoteMap","");
			case 6: vote(msg,NominatedMaps[1],NominatedMaps[2],NominatedMaps[3],NominatedMaps[4],NominatedMaps[5],NominatedMaps[6],"HVoteMap","");
			case 7: vote(msg,NominatedMaps[1],NominatedMaps[2],NominatedMaps[3],NominatedMaps[4],NominatedMaps[5],NominatedMaps[6],NominatedMaps[7],"HVoteMap","");
			case 8: vote(msg,NominatedMaps[1],NominatedMaps[2],NominatedMaps[3],NominatedMaps[4],NominatedMaps[5],NominatedMaps[6],NominatedMaps[7],NominatedMaps[8],"HVoteMap","");
		}
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"Keine Map in %s vorhanden",FileName);
		displayconsole(Text,"Fuer admin_vote_maps kann man mit","admin_vote_mapadd Maps anlegen!");
		reset_votesettings();
	}
}

/*ALLES FR DAS MULTIMAPVOTING*/
public vote_multimap(Timer,Repeat,HLUser,HLParam){
	if(multimapstart==0){
		new Text[MAX_TEXT_LENGTH];
		multimapstart=1;
		mapdel(NOMINATEMAPS);
		sound_all(VoteNow);
		set_timer("warning",15,0);
		snprintf(Text,MAX_TEXT_LENGTH,"Gebt Euren Mapvorschlag im chat ab!^n Beispiel: 'vote de_dust'^n Ihr habt %i Sekunden Zeit",votetimeorig);
		displayall(Text);
	}else{
		displayconsole("","Multimapvote ist bereits gestartet!!!","");
	}
	return PLUGIN_CONTINUE;
}

/*10.12.02: votetime ist jetzt variable in der vault.ini zusetzen*/
public warning(Timer,Repeat,HLUser,HLParam){
	if(multimapstart==1){
		new Text[MAX_TEXT_LENGTH];
		votetime=votetime - 15;
		/*Abbruch der Schleife*/
		if(votetime<=14){
			show_results();
			return PLUGIN_CONTINUE;
		}
		sound_all(Bell);
		snprintf(Text,MAX_TEXT_LENGTH,"Gebt Euren Mapvorschlag im chat ab!^n Beispiel: 'vote de_dust'^n Ihr habt noch %i Sekunden Zeit",votetime);
		say(Text);
		/*Schleife, bis votetime <= 14 ist.*/
		set_timer("warning",15,0);
	}else{
		vote_canceled=0;
	}
	return PLUGIN_CONTINUE;
}

show_results(){
	new Text[MAX_TEXT_LENGTH];
	new i;
	new j;
	new maxplayers=maxplayercount();
	new x;
	new add=0;

	for(i=1;i<=maxplayers;i++){
		if(add==8){
			break;
		}
		if(strlen(MapCandidates[i])!=0){
			if(add==0){
				strcpy(NominatedMaps[add],MapCandidates[i],MAX_NAME_LENGTH);
				mapwrite(NOMINATEMAPS,MapCandidates[i],0);
				add ++;
			}else{
				for(j=0;j<=add;j++){
					if(strcmp(MapCandidates[i],NominatedMaps[j])==0){
						x=1;
						break;
					}
				}
				if(x!=1){
					add ++;
					strcpy(NominatedMaps[add],MapCandidates[i],MAX_NAME_LENGTH);
					mapwrite(NOMINATEMAPS,MapCandidates[i],0);
				}
				x=0;
			}
		}
	}
	if(add==0){
		sound_all(VoteFailed);
		snprintf(Text,MAX_TEXT_LENGTH,"Es wurden keine Vorschlaege gemacht!");
		displayall(Text);
		reset_votesettings();
	}else{
		if (vote_allowed()!=1) {
			displayconsole("Multimap-Vote kann nicht ausgefuehrt werden!","Bitte manuell ausfuehren!","");
			reset_votesettings();
		}
		snprintf(Text,MAX_TEXT_LENGTH,"Nach der Auszaehlung der Vorschlaege^n sind folgende Maps nominiert! ^nBitte voten!");
		displayall(Text);
		for(i=0;i<=maxplayers;i++){
			strcpy(MapCandidates[i],"",MAX_NAME_LENGTH);
		}
		nominate=0;
		votemaps(NOMINATEMAPS);
	}
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Map[MAX_NAME_LENGTH];
	new CurMap[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new Dummy[5];
	new Command[MAX_NAME_LENGTH];
	new i;
	new PublicVote[MAX_NAME_LENGTH];
	new iLine;
	new x;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strstripquotes(Data);
	currentmap(CurMap,MAX_NAME_LENGTH);
	if(strncmp(Data,"vote_",5)==0){
		if((allowpublic==1 && check_admin()==0) || check_auth(2)==1){
			if(vote_allowed()==1 && multimapstart==0){
				strsep(Data,"_",Dummy,5,Command,MAX_NAME_LENGTH);
				new File[MAX_TEXT_LENGTH];
				snprintf(File,MAX_TEXT_LENGTH,"%s%s",FileDir,PUBLICVOTES);
				iLine=filesize(File);
				for(i=1;i<=iLine;i++){
					readfile(File,PublicVote,i,MAX_NAME_LENGTH);
					if(strstr(Command,PublicVote)==0){
						vote_public(Command,User);
						x=1;
						break;
					}
				}
				if(x!=1){
					snprintf(Text,MAX_TEXT_LENGTH,"Dir stehen folgende Votes mit 'vote_xxx' im Chat zur Verfuegung:");
					messageex(User,Text,print_chat);
					snprintf(Text,MAX_TEXT_LENGTH,"xxx: ");
					for(i=1;i<=iLine;i++){
						readfile(File,PublicVote,i,MAX_NAME_LENGTH);
						snprintf(Text,MAX_TEXT_LENGTH,"%s %s",Text,PublicVote);
					}
					messageex(User,Text,print_chat);
				}

			}else{
				messageex(User,"Zur Zeit sind keine Votes erlaubt!",print_chat);
			}
		}else{
			messageex(User,"Du darfst zur Zeit keine Votes im Chat starten!",print_chat);
		}
		return PLUGIN_CONTINUE;
	}
	if(strstr(Data,"vote")==0){
		strbreak(Data,Data,Map,MAX_NAME_LENGTH);
		if(maprestriction==1){
			for(i=0;i<anzahl;i++){
				if(strcmp(Map,LastMaps[i])==0){
					snprintf(Text,MAX_TEXT_LENGTH,"%s lief erst vor kurzem und kann nicht nochmal nominiert werden!",Map);
					messageex(User,Text,print_chat);
					return PLUGIN_CONTINUE;
					break;
				}
			}
		}
		if(strcmp(Map,"extend")==0 || strcmp(Map,CurMap)==0){
			if(ValueStatus[EXTEND]<origextend){
				strcpy(Map,CurMap,MAX_NAME_LENGTH);
			}else{
				messageex(User,"Die Map kann nicht nochmal verlaengert werden!",print_chat);
				return PLUGIN_CONTINUE;
			}
		}
		if(valid_map(Map)!=1){
			messageex(User,"Die Map ist nicht gueltig!",print_chat);
			return PLUGIN_HANDLED;
		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"%s hat %s als Mapvorschlag abgegeben!",User,Map);
			say(Text);
			strcpy(MapCandidates[UserIndex],Map,MAX_NAME_LENGTH);
			nominate++;
			if(maxnominate!=0 && maxnominate==nominate){
				mapdel(NOMINATEMAPS);
				show_results();
			}
		}
	}

	return PLUGIN_CONTINUE;
}

/*--- DIE VOTE_AUSWERTUNG FR DEN MULTIMAPVOTE ---*/

public HVoteMap(WinningOption,HLMap,VoteCount,UserCount) {

	new Msg[MAX_TEXT_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new Map[MAX_TEXT_LENGTH];

	votestarted=0;

	if(WinningOption>0 && vote_canceled==0 ){

		snprintf(Msg,MAX_TEXT_LENGTH,"%s wurde mit %i Stimme(n) von %i Stimme(n) gevotet!^n",NominatedMaps[WinningOption],VoteCount,UserCount);
		say(Msg);
		currentmap(Map,MAX_TEXT_LENGTH);
		if(strcmp(NominatedMaps[WinningOption],Map)==0){
			reset_votesettings();
			extend(voteend);
			sound_all(VotePassed);
		}else{
			reset_votesettings();
			mapchange(NominatedMaps[WinningOption],voteend);
			sound_all(VotePassed);
		}
	}else{
		vote_canceled=0;
		reset_votesettings();
		snprintf(Text,MAX_TEXT_LENGTH,"Leider nicht genug Stimmen abgegeben!");
		displayall(Text);
		sound_all(VoteFailed);
	}
	return PLUGIN_CONTINUE;
}

/*--- DIE VOTE_AUSWERTUNG FR ALLE JA/NEIN VOTES ---*/
public NormVote(WinningOption,HLMap,VoteCount,UserCount) {

	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new number;

	convert_string(HLMap,Data,MAX_DATA_LENGTH);

	votestarted=0;

	new Ratio;
	Ratio=getvar("admin_vote_ratio");
	number=Ratio*UserCount/100;
	if(WinningOption==1 && vote_canceled == 0){
		if (VoteCount >= number ) {
			sound_all(VotePassed);
			switch(voteidentify){
				case AWP: 		awp(voteend);
				case CHASECAM: 		chasecam(voteend);
				case EXTEND: 		extend(voteend);
				case FF: 		ff(voteend);
				case GRAVITY: 		gravity(Data,voteend);
				case MAPCHANGE: 	mapchange(Data,voteend);
				case PISTOLS: 		pistols(voteend);
				case KICKPLAYER: 	kickplayer(Data,voteend);
				case SLAPPLAYER: 	slapplayer(Data,voteend);
				case SLAYPLAYER: 	slayplayer(Data,voteend);
				case BANPLAYER: 	banplayer(Data,voteend);
				case BURYPLAYER: 	buryplayer(Data,voteend);
				case RESTARTROUND: 	restart(voteend);
			}
		} else {
			snprintf(Text, MAX_TEXT_LENGTH, "Vote abgeschlossen, aber nicht ^ngenug JA-Stimmen erhalten (notwendig %i)", number);
			displayall(Text);
			sound_all(VoteFailed);
		}
	} else {
		snprintf(Text, MAX_TEXT_LENGTH, "Vote abgeschlossen, aber nicht ^ngenug JA-Stimmen erhalten (notwendig %i)", number);
		displayall(Text);
		sound_all(VoteFailed);
	}
	vote_canceled=0;
	reset_votesettings();
	return PLUGIN_CONTINUE;
}

public plugin_command(HLCommand, HLData, HLUserName, UserIndex){

	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new iSelect;

	convert_string(HLCommand, Command, MAX_COMMAND_LENGTH);
	convert_string(HLData, Data, MAX_DATA_LENGTH);
	convert_string(HLUserName, User, MAX_NAME_LENGTH);

	if(votestarted==1){
		if(Command[0]=='m'){
			if(BuyPlayer[UserIndex]!=1){
				BuyPlayer[UserIndex]=1;
				iSelect=strtonum(Data);
				if(multimapstart==1){
					snprintf(Text,MAX_TEXT_LENGTH,"%s hat fuer %s gevotet",User,NominatedMaps[iSelect]);
				}else{
					if(iSelect==1){
						snprintf(Text,MAX_TEXT_LENGTH,"%s hat fuer 'Ja' gestimmt",User);
					}else{
						snprintf(Text,MAX_TEXT_LENGTH,"%s hat fuer 'Nein' gestimmt",User);
					}
				}
				say(Text);
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public plugin_init() {

	plugin_registerinfo("Vote-For-It","Starts multiple votings especially multi-map-voting, edited for CS 1.6",STRING_VERSION);
	plugin_registercmd("admin_vote_awp","admin_vote",ACCESS_VOTE_MAP,"admin_vote_awp: starts a vote for or against using awp");
	plugin_registercmd("admin_vote_ban","admin_vote",ACCESS_VOTE_MAP,"admin_vote_banplayer <name> (<votetime>): starts a vote for or against a player");
	plugin_registercmd("admin_vote_bury","admin_vote",ACCESS_VOTE_MAP,"admin_vote_buryplayer <name> (<votetime>): starts a vote for or against a player");
	plugin_registercmd("admin_vote_cancel","admin_vote_cancel",ACCESS_VOTE_MAP,"admin_vote_cancel (<votetime>): cancels the voting");
	plugin_registercmd("admin_vote_chasecam","admin_vote",ACCESS_VOTE_MAP,"admin_vote_chasecam (<votetime>): starts a vote for or against using chasecam");
	plugin_registercmd("admin_vote_extend","admin_vote",ACCESS_VOTE_MAP,"admin_vote_extend (<votetime>): starts a vote for extendig the map");
	plugin_registercmd("admin_vote_ff","admin_vote",ACCESS_VOTE_MAP,"admin_vote_ff (<votetime>): starts a vote for or against friendly fire");
	plugin_registercmd("admin_vote_gravity","admin_vote",ACCESS_VOTE_MAP,"admin_vote_gravity <number> (<votetime>): starts a vote for or against changing gravity");
	plugin_registercmd("admin_vote_kick","admin_vote",ACCESS_VOTE_MAP,"admin_vote_kick <name> (<votetime>): starts a vote for or against a player");
	plugin_registercmd("admin_vote_map","admin_vote",ACCESS_VOTE_MAP,"admin_vote_map <mapname> (<votetime>): starts a vote for or against a map");
	plugin_registercmd("admin_vote_maps","admin_vote_maps",ACCESS_VOTE_MAP,"admin_vote_maps (<votetime>): starts a multi-map-vote");
	plugin_registercmd("admin_vote_multimap","admin_vote_multimap",ACCESS_VOTE_MAP,"admin_vote_multimap: players can make map suggestions ");
	plugin_registercmd("admin_vote_pistols","admin_vote",ACCESS_VOTE_MAP,"admin_vote_pistols (<votetime>): starts a vote for or against using obly pistols");
	plugin_registercmd("admin_vote_rr","admin_vote",ACCESS_VOTE_MAP,"admin_vote_rr <time> (<votetime>): starts a vote for or against restarting the map");
	plugin_registercmd("admin_vote_slap","admin_vote",ACCESS_VOTE_MAP,"admin_vote_slapplayer <name> (<votetime>): starts a vote for or against a player");
	plugin_registercmd("admin_vote_slay","admin_vote",ACCESS_VOTE_MAP,"admin_vote_slayplayer <name> (<votetime>): starts a vote for or against a player");
	/*For Settings only*/
	plugin_registercmd("admin_vote_mapadd","admin_vote_mapadd",ACCESS_VOTE_SETTINGS,"VFI-Setting - admin_vote_mapadd <mapname> <opt. filename>: adds map in 'FileName'.ini, default: mapvote.ini");
	plugin_registercmd("admin_vote_mapdel","admin_vote_mapdel",ACCESS_VOTE_SETTINGS,"VFI-Setting - admin_vote_mapdel <opt. filename>: resets the 'filename'.ini, default: mapvote.ini");
	plugin_registercmd("admin_vote_maplist","admin_vote_maplist",ACCESS_VOTE_SETTINGS,"VFI-Setting - admin_vote_maplist <opt. filename>: list of maps in 'filename'.ini, default: mapvote.ini");
	plugin_registercmd("admin_vote_sound","admin_vote_sound",ACCESS_VOTE_SETTINGS,"VFI-Setting - admin_vote_sound <0/1>: turns vote-sounds off/on");
	plugin_registercmd("admin_vote_public","admin_vote_public",ACCESS_VOTE_SETTINGS,"VFI-Setting - admin_vote_public <0/1>: allows all players using votes except ban-vote");
	plugin_registercmd("admin_vote_maxnom","admin_vote_maxnom",ACCESS_VOTE_SETTINGS," VFI-Setting - admin_vote_maxnom <0/max.8>: starts multimap-vote, if enough suggestions are made");
	plugin_registercmd("admin_vote_restrict","admin_vote_restrict",ACCESS_VOTE_SETTINGS,"VFI-Setting - admin_vote_restrict <0/1>: last four maps are restricted to be nominated again (off/on)");
	plugin_registercmd("say","HandleSay",ACCESS_ALL,"");

	/*Debug-Funktion*/
	plugin_registercmd("admin_vote_debug","admin_vote_debug",ACCESS_VOTE_SETTINGS,"VFI-Setting - admin_vote_debug <vault/game/server/vote/nomin/restr/public>: displays settings");

	/*--- SERVEREINSTELLUNGEN HERRAUSFINDEN ---*/
	/*--- UND STATUS-VALUES ANPASSEN	---*/
	origTimelimit 		= getvar("mp_timelimit");
	origextend		= getvar("admin_vote_maxextend");
	ValueStatus[FF]		= getvar("mp_friendlyfire");
	ValueStatus[GRAVITY]	= getvar("sv_gravity");
	ValueStatus[CHASECAM] 	= getvar("mp_forcechasecam");
	if(ValueStatus[CHASECAM]==2){
		ValueStatus[CHASECAM]=1;
	}
	getstrvar("amv_vote_duration",OrigVoteDuration,MAX_NUMBER_LENGTH);

	/*Vault.ini auslesen*/
	get_vaultdata( "VFI_VOTEWARN", Bell, MAX_TEXT_LENGTH );
	get_vaultdata( "VFI_VOTENOW", VoteNow, MAX_TEXT_LENGTH );
	get_vaultdata( "VFI_VOTEPASSED", VotePassed, MAX_TEXT_LENGTH );
	get_vaultdata( "VFI_VOTEFAILED", VoteFailed, MAX_TEXT_LENGTH );
	get_vaultnumdata( "VFI_PUBLIC",allowpublic);
	get_vaultnumdata( "VFI_SOUNDSALLOWED", soundsallowed);
	/*10.12.02: Vote-Duration des admin_vote_multimap aus der vault.ini auslesen*/
	get_vaultnumdata( "VFI_TIMETONOMINATE",votetimeorig);
	get_vaultnumdata( "VFI_MAXNOMINATIONS",maxnominate);
	get_vaultnumdata( "VFI_MAPRESTRICTION",maprestriction);
	if(votetimeorig<=0){
		votetimeorig=60;
	}
	votetime=votetimeorig;
	mapread(LastMapsINI,0);
	return PLUGIN_CONTINUE;
}